#ifdef ENABLE_BIT_DEFINITIONS


/* Bit definitions for use with the IAR Assembler   
   The Register Bit names are represented by their bit number (0-7).
*/

/* TCCR2A */
#define COM2A1 7
#define COM2A0 6
#define COM2B1 5
#define COM2B0 4
#define WGM21 1
#define WGM20 0

/* TCCR2B */
#define ICNC2 7
#define ICES2 6
#define WGM23 4
#define WGM22 3
#define CS22 2
#define CS21 1
#define CS20 0

/* TCCR2C */
#define FOC2A 7
#define FOC2B 6

/* TCNT2 */
#define TCNT215 7
#define TCNT214 6
#define TCNT213 5
#define TCNT212 4
#define TCNT211 3
#define TCNT210 2
#define TCNT29 1
#define TCNT28 0
#define TCNT27 7
#define TCNT26 6
#define TCNT25 5
#define TCNT24 4
#define TCNT23 3
#define TCNT22 2
#define TCNT21 1
#define TCNT20 0

/* OCR2A */
#define OCR2A15 7
#define OCR2A14 6
#define OCR2A13 5
#define OCR2A12 4
#define OCR2A11 3
#define OCR2A10 2
#define OCR2A9 1
#define OCR2A8 0
#define OCR2A7 7
#define OCR2A6 6
#define OCR2A5 5
#define OCR2A4 4
#define OCR2A3 3
#define OCR2A2 2
#define OCR2A1 1
#define OCR2A0 0

/* OCR2B */
#define OCR2B15 7
#define OCR2B14 6
#define OCR2B13 5
#define OCR2B12 4
#define OCR2B11 3
#define OCR2B10 2
#define OCR2B9 1
#define OCR2B8 0
#define OCR2B7 7
#define OCR2B6 6
#define OCR2B5 5
#define OCR2B4 4
#define OCR2B3 3
#define OCR2B2 2
#define OCR2B1 1
#define OCR2B0 0

/* ICR2 */
#define ICR215 7
#define ICR214 6
#define ICR213 5
#define ICR212 4
#define ICR211 3
#define ICR210 2
#define ICR29 1
#define ICR28 0
#define ICR27 7
#define ICR26 6
#define ICR25 5
#define ICR24 4
#define ICR23 3
#define ICR22 2
#define ICR21 1
#define ICR20 0

/* SPCR */
#define SPIE 7
#define SPE 6
#define DORD 5
#define MSTR 4
#define CPOL 3
#define CPHA 2
#define SPR1 1
#define SPR0 0

/* SPSR */
#define SPIF 7
#define WCOL 6
#define SPI2X 0

/* SPDR */
#define SPDR7 7
#define SPDR6 6
#define SPDR5 5
#define SPDR4 4
#define SPDR3 3
#define SPDR2 2
#define SPDR1 1
#define SPDR0 0

/* TWSCRA */
#define TWSHE 7
#define TWDIE 5
#define TWASIE 4
#define TWEN 3
#define TWSIE 2
#define TWPME 1
#define TWSME 0

/* TWSCRB */
#define TWHNM 3
#define TWAA 2
#define TWCMD1 1
#define TWCMD0 0

/* TWSSRA */
#define TWDIF 7
#define TWASIF 6
#define TWCH 5
#define TWRA 4
#define TWC 3
#define TWBE 2
#define TWDIR 1
#define TWAS 0

/* TWSA */
#define TWSA7 7
#define TWSA6 6
#define TWSA5 5
#define TWSA4 4
#define TWSA3 3
#define TWSA2 2
#define TWSA1 1
#define TWSA0 0

/* TWSAM */
#define TWSAM7 7
#define TWSAM6 6
#define TWSAM5 5
#define TWSAM4 4
#define TWSAM3 3
#define TWSAM2 2
#define TWSAM1 1
#define TWAE 0

/* TWSD */
#define TWSD7 7
#define TWSD6 6
#define TWSD5 5
#define TWSD4 4
#define TWSD3 3
#define TWSD2 2
#define TWSD1 1
#define TWSD0 0

/* UCSR1A */
#define RXC1 7
#define TXC1 6
#define UDRE1 5
#define FE1 4
#define DOR1 3
#define UPE1 2
#define U2X1 1
#define MPCM1 0

/* UCSR1B */
#define RXCIE1 7
#define TXCIE1 6
#define UDRIE1 5
#define RXEN1 4
#define TXEN1 3
#define UCSZ12 2
#define RXB81 1
#define TXB81 0

/* UCSR1C */
#define UMSEL11 7
#define UMSEL10 6
#define UPM11 5
#define UPM10 4
#define USBS1 3
#define UCSZ11 2
#define UCSZ10 1
#define UCPOL1 0

/* UCSR1D */
#define RXSIE1 7
#define RXS1 6
#define SFDE1 5

/* UBRR1 */
#define UBRR111 3
#define UBRR110 2
#define UBRR19 1
#define UBRR18 0
#define UBRR17 7
#define UBRR16 6
#define UBRR15 5
#define UBRR14 4
#define UBRR13 3
#define UBRR12 2
#define UBRR11 1
#define UBRR10 0

/* UDR1 */
#define UDR17 7
#define UDR16 6
#define UDR15 5
#define UDR14 4
#define UDR13 3
#define UDR12 2
#define UDR11 1
#define UDR10 0

/* UCSR0A */
#define RXC0 7
#define TXC0 6
#define UDRE0 5
#define FE0 4
#define DOR0 3
#define UPE0 2
#define U2X0 1
#define MPCM0 0

/* UCSR0B */
#define RXCIE0 7
#define TXCIE0 6
#define UDRIE0 5
#define RXEN0 4
#define TXEN0 3
#define UCSZ02 2
#define RXB80 1
#define TXB80 0

/* UCSR0C */
#define UMSEL01 7
#define UMSEL00 6
#define UPM01 5
#define UPM00 4
#define USBS0 3
#define UCSZ01 2
#define UCSZ00 1
#define UCPOL0 0

/* UCSR0D */
#define RXSIE0 7
#define RXS0 6
#define SFDE0 5

/* UBRR0 */
#define UBRR011 3
#define UBRR010 2
#define UBRR09 1
#define UBRR08 0
#define UBRR07 7
#define UBRR06 6
#define UBRR05 5
#define UBRR04 4
#define UBRR03 3
#define UBRR02 2
#define UBRR01 1
#define UBRR00 0

/* UDR0 */
#define UDR07 7
#define UDR06 6
#define UDR05 5
#define UDR04 4
#define UDR03 3
#define UDR02 2
#define UDR01 1
#define UDR00 0

/* OSCCAL1 */
#define OSCCAL11 1
#define OSCCAL10 0

/* OSCTCAL0B */
#define OSCTCAL0B7 7
#define OSCTCAL0B6 6
#define OSCTCAL0B5 5
#define OSCTCAL0B4 4
#define OSCTCAL0B3 3
#define OSCTCAL0B2 2
#define OSCTCAL0B1 1
#define OSCTCAL0B0 0

/* OSCTCAL0A */
#define OSCTCAL0A7 7
#define OSCTCAL0A6 6
#define OSCTCAL0A5 5
#define OSCTCAL0A4 4
#define OSCTCAL0A3 3
#define OSCTCAL0A2 2
#define OSCTCAL0A1 1
#define OSCTCAL0A0 0

/* OSCCAL0 */
#define OSCCAL07 7
#define OSCCAL06 6
#define OSCCAL05 5
#define OSCCAL04 4
#define OSCCAL03 3
#define OSCCAL02 2
#define OSCCAL01 1
#define OSCCAL00 0

/* CLKPR */
#define CLKPS3 3
#define CLKPS2 2
#define CLKPS1 1
#define CLKPS0 0

/* CLKCR */
#define OSCRDY 7
#define CSTR 6
#define CKOUTC 5
#define SUT 4
#define CKSEL3 3
#define CKSEL2 2
#define CKSEL1 1
#define CKSEL0 0

/* CCP */
#define CCP7 7
#define CCP6 6
#define CCP5 5
#define CCP4 4
#define CCP3 3
#define CCP2 2
#define CCP1 1
#define CCP0 0

/* PRR */
#define PRTWI 7
#define PRUSART1 6
#define PRUSART0 5
#define PRSPI 4
#define PRTIM2 3
#define PRTIM1 2
#define PRTIM0 1
#define PRADC 0

/* PHDE */
#define PHDEA1 1
#define PHDEA0 0

/* TOCPMSA1 */
#define TOCC7S1 7
#define TOCC7S0 6
#define TOCC6S1 5
#define TOCC6S0 4
#define TOCC5S1 3
#define TOCC5S0 2
#define TOCC4S1 1
#define TOCC4S0 0

/* TOCPMSA0 */
#define TOCC3S1 7
#define TOCC3S0 6
#define TOCC2S1 5
#define TOCC2S0 4
#define TOCC1S1 3
#define TOCC1S0 2
#define TOCC0S1 1
#define TOCC0S0 0

/* TOCPMCOE */
#define TOCC7OE 7
#define TOCC6OE 6
#define TOCC5OE 5
#define TOCC4OE 4
#define TOCC3OE 3
#define TOCC2OE 2
#define TOCC1OE 1
#define TOCC0OE 0

/* REMAP */
#define U0MAP 1
#define SPIMAP 0

/* PORTCR */
#define BBMB 1
#define BBMA 0

/* PUEA */
#define PUEA7 7
#define PUEA6 6
#define PUEA5 5
#define PUEA4 4
#define PUEA3 3
#define PUEA2 2
#define PUEA1 1
#define PUEA0 0

/* PUEB */
#define PUEB3 3
#define PUEB2 2
#define PUEB1 1
#define PUEB0 0

/* DIDR1 */
#define ADC9D 3
#define ADC8D 2
#define ADC10D 1
#define ADC11D 0

/* DIDR0 */
#define ADC7D 7
#define ADC6D 6
#define ADC5D 5
#define ADC4D 4
#define ADC3D 3
#define ADC2D 2
#define ADC1D 1
#define ADC0D 0

/* SP */
#define SP10 2
#define SP9 1
#define SP8 0
#define SP7 7
#define SP6 6
#define SP5 5
#define SP4 4
#define SP3 3
#define SP2 2
#define SP1 1
#define SP0 0

/* OCR0B */
#define OCR0B7 7
#define OCR0B6 6
#define OCR0B5 5
#define OCR0B4 4
#define OCR0B3 3
#define OCR0B2 2
#define OCR0B1 1
#define OCR0B0 0

/* GIMSK */
#define INT0 6
#define PCIE1 5
#define PCIE0 4

/* GIFR */
#define INTF0 6
#define PCIF1 5
#define PCIF0 4

/* TIMSK0 */
#define OCIE0B 2
#define OCIE0A 1
#define TOIE0 0

/* TIFR0 */
#define OCF0B 2
#define OCF0A 1
#define TOV0 0

/* SPMCSR */
#define RSIG 5
#define CTPB 4
#define RFLB 3
#define PGWRT 2
#define PGERS 1
#define SPMEN 0

/* OCR0A */
#define OCR0A7 7
#define OCR0A6 6
#define OCR0A5 5
#define OCR0A4 4
#define OCR0A3 3
#define OCR0A2 2
#define OCR0A1 1
#define OCR0A0 0

/* MCUCR */
#define SE 5
#define SM1 4
#define SM0 3
#define ISC01 1
#define ISC00 0

/* MCUSR */
#define WDRF 3
#define BORF 2
#define EXTRF 1
#define PORF 0

/* TCCR0B */
#define FOC0A 7
#define FOC0B 6
#define WGM02 3
#define CS02 2
#define CS01 1
#define CS00 0

/* TCNT0 */
#define TCNT07 7
#define TCNT06 6
#define TCNT05 5
#define TCNT04 4
#define TCNT03 3
#define TCNT02 2
#define TCNT01 1
#define TCNT00 0

/* TCCR0A */
#define COM0A1 7
#define COM0A0 6
#define COM0B1 5
#define COM0B0 4
#define WGM01 1
#define WGM00 0

/* TCCR1A */
#define COM1A1 7
#define COM1A0 6
#define COM1B1 5
#define COM1B0 4
#define WGM11 1
#define WGM10 0

/* TCCR1B */
#define ICNC1 7
#define ICES1 6
#define WGM13 4
#define WGM12 3
#define CS12 2
#define CS11 1
#define CS10 0

/* TCNT1 */
#define TCNT115 7
#define TCNT114 6
#define TCNT113 5
#define TCNT112 4
#define TCNT111 3
#define TCNT110 2
#define TCNT19 1
#define TCNT18 0
#define TCNT17 7
#define TCNT16 6
#define TCNT15 5
#define TCNT14 4
#define TCNT13 3
#define TCNT12 2
#define TCNT11 1
#define TCNT10 0

/* OCR1A */
#define OCR1A15 7
#define OCR1A14 6
#define OCR1A13 5
#define OCR1A12 4
#define OCR1A11 3
#define OCR1A10 2
#define OCR1A9 1
#define OCR1A8 0
#define OCR1A7 7
#define OCR1A6 6
#define OCR1A5 5
#define OCR1A4 4
#define OCR1A3 3
#define OCR1A2 2
#define OCR1A1 1
#define OCR1A0 0

/* OCR1B */
#define OCR1B15 7
#define OCR1B14 6
#define OCR1B13 5
#define OCR1B12 4
#define OCR1B11 3
#define OCR1B10 2
#define OCR1B9 1
#define OCR1B8 0
#define OCR1B7 7
#define OCR1B6 6
#define OCR1B5 5
#define OCR1B4 4
#define OCR1B3 3
#define OCR1B2 2
#define OCR1B1 1
#define OCR1B0 0

/* ICR1 */
#define ICR115 7
#define ICR114 6
#define ICR113 5
#define ICR112 4
#define ICR111 3
#define ICR110 2
#define ICR19 1
#define ICR18 0
#define ICR17 7
#define ICR16 6
#define ICR15 5
#define ICR14 4
#define ICR13 3
#define ICR12 2
#define ICR11 1
#define ICR10 0

/* GTCCR */
#define TSM 7
#define PSR 0

/* TCCR1C */
#define FOC1A 7
#define FOC1B 6

/* WDTCSR */
#define WDIF 7
#define WDIE 6
#define WDE 3
#define WDP2 2
#define WDP1 1
#define WDP0 0

/* PCMSK1 */
#define PCMSK13 3
#define PCMSK12 2
#define PCMSK11 1
#define PCMSK10 0

/* EEAR */
#define EEAR8 0
#define EEAR7 7
#define EEAR6 6
#define EEAR5 5
#define EEAR4 4
#define EEAR3 3
#define EEAR2 2
#define EEAR1 1
#define EEAR0 0

/* EEDR */
#define EEDR7 7
#define EEDR6 6
#define EEDR5 5
#define EEDR4 4
#define EEDR3 3
#define EEDR2 2
#define EEDR1 1
#define EEDR0 0

/* EECR */
#define EEPM1 5
#define EEPM0 4
#define EERIE 3
#define EEMPE 2
#define EEPE 1
#define EERE 0

/* PORTA */
#define PORTA7 7
#define PORTA6 6
#define PORTA5 5
#define PORTA4 4
#define PORTA3 3
#define PORTA2 2
#define PORTA1 1
#define PORTA0 0

/* PA */
#define PA7 7
#define PA6 6
#define PA5 5
#define PA4 4
#define PA3 3
#define PA2 2
#define PA1 1
#define PA0 0

/* DDRA */
#define DDRA7 7
#define DDRA6 6
#define DDRA5 5
#define DDRA4 4
#define DDRA3 3
#define DDRA2 2
#define DDRA1 1
#define DDRA0 0

/* PINA */
#define PINA7 7
#define PINA6 6
#define PINA5 5
#define PINA4 4
#define PINA3 3
#define PINA2 2
#define PINA1 1
#define PINA0 0

/* PORTB */
#define PORTB3 3
#define PORTB2 2
#define PORTB1 1
#define PORTB0 0

/* PB */
#define PB3 3
#define PB2 2
#define PB1 1
#define PB0 0

/* DDRB */
#define DDRB3 3
#define DDRB2 2
#define DDRB1 1
#define DDRB0 0

/* PINB */
#define PINB3 3
#define PINB2 2
#define PINB1 1
#define PINB0 0

/* GPIOR2 */
#define GPIOR27 7
#define GPIOR26 6
#define GPIOR25 5
#define GPIOR24 4
#define GPIOR23 3
#define GPIOR22 2
#define GPIOR21 1
#define GPIOR20 0

/* GPIOR1 */
#define GPIOR17 7
#define GPIOR16 6
#define GPIOR15 5
#define GPIOR14 4
#define GPIOR13 3
#define GPIOR12 2
#define GPIOR11 1
#define GPIOR10 0

/* GPIOR0 */
#define GPIOR07 7
#define GPIOR06 6
#define GPIOR05 5
#define GPIOR04 4
#define GPIOR03 3
#define GPIOR02 2
#define GPIOR01 1
#define GPIOR00 0

/* PCMSK0 */
#define PCMSK07 7
#define PCMSK06 6
#define PCMSK05 5
#define PCMSK04 4
#define PCMSK03 3
#define PCMSK02 2
#define PCMSK01 1
#define PCMSK00 0

/* TIMSK2 */
#define ICIE2 5
#define OCIE2B 2
#define OCIE2A 1
#define TOIE2 0

/* TIFR2 */
#define ICF2 5
#define OCF2B 2
#define OCF2A 1
#define TOV2 0

/* TIMSK1 */
#define ICIE1 5
#define OCIE1B 2
#define OCIE1A 1
#define TOIE1 0

/* TIFR1 */
#define ICF1 5
#define OCF1B 2
#define OCF1A 1
#define TOV1 0

/* ACSR1B */
#define HSEL1 7
#define HLEV1 6
#define ACOE1 4
#define ACME1 2

/* ACSR1A */
#define ACD1 7
#define ACBG1 6
#define ACO1 5
#define ACI1 4
#define ACIE1 3
#define ACIC1 2
#define ACIS1 1
#define ACIS0 0

/* ACSR0B */
#define HSEL0 7
#define HLEV0 6
#define ACOE0 4
#define ACNMUX1 3
#define ACNMUX0 2
#define ACPMUX1 1
#define ACPMUX0 0

/* ACSR0A */
#define ACD0 7
#define ACPMUX2 6
#define ACO0 5
#define ACI0 4
#define ACIE0 3
#define ACIC0 2
// #define ACIS1 1
// #define ACIS0 0

/* ADMUXA */
#define MUX5 5
#define MUX4 4
#define MUX3 3
#define MUX2 2
#define MUX1 1
#define MUX0 0

/* ADMUXB */
#define REFS2 7
#define REFS1 6
#define REFS0 5
#define GSEL1 1
#define GSEL0 0

/* ADC */
#define ADC15 7
#define ADC14 6
#define ADC13 5
#define ADC12 4
#define ADC11 3
#define ADC10 2
#define ADC9 1
#define ADC8 0
#define ADC7 7
#define ADC6 6
#define ADC5 5
#define ADC4 4
#define ADC3 3
#define ADC2 2
#define ADC1 1
#define ADC0 0

/* ADCSRA */
#define ADEN 7
#define ADSC 6
#define ADATE 5
#define ADIF 4
#define ADIE 3
#define ADPS2 2
#define ADPS1 1
#define ADPS0 0

/* ADCSRB */
#define ADLAR 3
#define ADTS2 2
#define ADTS1 1
#define ADTS0 0


/* Pointer definition */
#define    XL     r26
#define    XH     r27
#define    YL     r28
#define    YH     r29
#define    ZL     r30
#define    ZH     r31

/* Constants */

#define    RAMEND     0x02FF    /*Last On-Chip SRAM location*/
#define    XRAMEND    RAMEND
#define    E2END      0x01FF
#define    FLASHEND   0x1FFF

#endif /* ENABLE_BIT_DEFINITIONS */ 

